# TerminalLoggers

[![Stable](https://img.shields.io/badge/docs-stable-blue.svg)](https://JuliaLogging.github.io/TerminalLoggers.jl/stable)
[![Dev](https://img.shields.io/badge/docs-dev-blue.svg)](https://JuliaLogging.github.io/TerminalLoggers.jl/dev)
[![Build Status](https://github.com/JuliaLogging/TerminalLoggers.jl/workflows/CI/badge.svg)](https://github.com/JuliaLogging/TerminalLoggers.jl/actions?query=workflow%3ACI)
[![Codecov](https://codecov.io/gh/JuliaLogging/TerminalLoggers.jl/branch/master/graph/badge.svg)](https://codecov.io/gh/JuliaLogging/TerminalLoggers.jl)

TerminalLoggers provides a logger type `TerminalLogger` which can format your
log messages in a richer way than the default `ConsoleLogger` which comes with
the julia standard `Logging` library.

Read the [documentation](https://JuliaLogging.github.io/TerminalLoggers.jl/stable) for
more information.

module TerminalLoggers

@doc let path = joinpath(dirname(@__DIR__), "README.md")
    include_dependency(path)
    replace(read(path, String), "```julia" => "```jldoctest")
end TerminalLoggers

using Logging:
    AbstractLogger,
    LogLevel, BelowMinLevel, Debug, Info, Warn, Error, AboveMaxLevel

import Logging:
    handle_message, shouldlog, min_enabled_level, catch_exceptions

using LeftChildRightSiblingTrees: Node, addchild, isroot, prunebranch!
using ProgressLogging: asprogress
using UUIDs: UUID

export TerminalLogger

const ProgressLevel = LogLevel(-1)

include("ProgressMeter/ProgressMeter.jl")
using .ProgressMeter:
    BarGlyphs

include("StickyMessages.jl")
include("ProgressBar.jl")
include("TerminalLogger.jl")

end # module

module ProgressMeter

using Printf: @printf, @sprintf

"""
Holds the five characters that will be used to generate the progress bar.
"""
mutable struct BarGlyphs
    leftend::Char
    fill::Char
    front::Union{Vector{Char}, Char}
    empty::Char
    rightend::Char
end

BarGlyphs() = BarGlyphs(
    '|',
    '█',
    Sys.iswindows() ? '█' : ['▏', '▎', '▍', '▌', '▋', '▊', '▉'],
    ' ',
    '|',
)

"""
    printprogress(io::IO, barglyphs::BarGlyphs, tfirst::Float64, desc, progress, eta_seconds::Real)

Print progress bar to `io`.

# Arguments
- `io::IO`
- `barglyphs::BarGlyphs`
- `tfirst::Float64`
- `desc`: description to be printed at left side of progress bar.
- `progress`: a number between 0 and 1 or `nothing`.
- `eta_seconds::Real`: ETA in seconds
"""
function printprogress(
    io::IO,
    barglyphs::BarGlyphs,
    tfirst::Float64,
    desc,
    progress,
    eta_seconds::Real,
)
    t = time()
    percentage_complete = 100.0 * (isnothing(progress) || isnan(progress) ? 0.0 : progress)

    #...length of percentage and ETA string with days is 29 characters
    barlen = max(0, displaysize(io)[2] - (length(desc) + 29))

    if !isnothing(progress) && progress >= 1
        bar = barstring(barlen, percentage_complete, barglyphs=barglyphs)
        dur = durationstring(t - tfirst)
        @printf io "%s%3u%%%s Time: %s" desc round(Int, percentage_complete) bar dur
        return
    end

    bar = barstring(barlen, percentage_complete, barglyphs=barglyphs)
    if 0 <= eta_seconds <= typemax(Int)
        eta_sec = round(Int, eta_seconds)
        eta = durationstring(eta_sec)
    else
        eta = "N/A"
    end
    @printf io "%s%3u%%%s  ETA: %s" desc round(Int, percentage_complete) bar eta
    return
end

function compute_front(barglyphs::BarGlyphs, frac_solid::AbstractFloat)
    barglyphs.front isa Char && return barglyphs.front
    idx = round(Int, frac_solid * (length(barglyphs.front) + 1))
    return idx > length(barglyphs.front) ? barglyphs.fill :
           idx == 0 ? barglyphs.empty :
           barglyphs.front[idx]
end

function barstring(barlen, percentage_complete; barglyphs)
    bar = ""
    if barlen>0
        if percentage_complete == 100 # if we're done, don't use the "front" character
            bar = string(barglyphs.leftend, repeat(string(barglyphs.fill), barlen), barglyphs.rightend)
        else
            n_bars = barlen * percentage_complete / 100
            nsolid = trunc(Int, n_bars)
            frac_solid = n_bars - nsolid
            nempty = barlen - nsolid - 1
            bar = string(barglyphs.leftend,
                         repeat(string(barglyphs.fill), max(0,nsolid)),
                         compute_front(barglyphs, frac_solid),
                         repeat(string(barglyphs.empty), max(0, nempty)),
                         barglyphs.rightend)
        end
    end
    bar
end

function durationstring(nsec)
    days = div(nsec, 60*60*24)
    r = nsec - 60*60*24*days
    hours = div(r,60*60)
    r = r - 60*60*hours
    minutes = div(r, 60)
    seconds = floor(r - 60*minutes)

    hhmmss = @sprintf "%u:%02u:%02u" hours minutes seconds
    if days>9
        return @sprintf "%.2f days" nsec/(60*60*24)
    elseif days>0
        return @sprintf "%u days, %s" days hhmmss
    end
    hhmmss
end

# issue #31: isnothing require Julia 1.1
# copy-over from
# https://github.com/JuliaLang/julia/blob/0413ef0e4de83b41b637ba02cc63314da45fe56b/base/some.jl
if !isdefined(Base, :isnothing)
    isnothing(::Any) = false
    isnothing(::Nothing) = true
end

end

Base.@kwdef mutable struct ProgressBar
    fraction::Union{Float64,Nothing}
    name::String
    level::Int = 0
    barglyphs::BarGlyphs = BarGlyphs()
    tlast::Float64 = time()
    tfirst::Float64 = time()
    id::UUID
    parentid::UUID
end

set_fraction!(bar::ProgressBar, ::Nothing) = bar
function set_fraction!(bar::ProgressBar, fraction::Real)
    bar.tlast = time()
    bar.fraction = fraction
    return bar
end

# This is how `ProgressMeter.printprogress` decides "ETA" vs "Time":
ensure_done!(bar::ProgressBar) = bar.fraction = 1

function eta_seconds(bar)
    total = (bar.tlast - bar.tfirst) / something(bar.fraction, NaN)
    return total - (time() - bar.tfirst)
end


function printprogress(io::IO, bar::ProgressBar)
    if bar.name == ""
        desc = "Progress: "
    else
        desc = bar.name
        if !endswith(desc, " ")
            desc *= " "
        end
    end

    pad = "  "^bar.level
    print(io, pad)

    lines, columns = displaysize(io)
    ProgressMeter.printprogress(
        IOContext(io, :displaysize => (lines, max(1, columns - length(pad)))),
        bar.barglyphs,
        bar.tfirst,
        desc,
        bar.fraction,
        eta_seconds(bar),
    )
end

"""
    StickyMessages(io::IO; ansi_codes=io isa Base.TTY && 
                   (!Sys.iswindows() || VERSION >= v"1.5.3"))

A `StickyMessages` type manages the display of a set of persistent "sticky"
messages in a terminal. That is, messages which are not part of the normal
scrolling output. Each message is identified by a label and may may be added to
the set using `push!(messages, label=>msg)`, and removed using
`pop!(messages, label)`, or `empty!()`.

Only a single StickyMessages object should be associated with a given TTY, as
the object manipulates the terminal scrolling region.
"""
mutable struct StickyMessages
    io::IO
    # Bool for controlling TTY escape codes.
    ansi_codes::Bool
    # Messages is just used as a (short) OrderedDict here
    messages::Vector{Pair{Any,String}}
end

function StickyMessages(io::IO; ansi_codes=io isa Base.TTY &&
        # scroll region code on Windows only works with recent libuv, present in 1.5.3+
        (!Sys.iswindows() || VERSION >= v"1.5.3"))
    sticky = StickyMessages(io, ansi_codes, Vector{Pair{Any,String}}())
    # Ensure we clean up the terminal
    finalizer(sticky) do sticky
        # See also empty!()
        if !sticky.ansi_codes
            return
        end
        prev_nlines = _countlines(sticky.messages)
        if prev_nlines > 0
            # Clean up sticky lines. Hack: must be async to do the IO outside
            # of finalizer. Proper fix would be an uninstall event triggered by
            # with_logger.
            @async showsticky(sticky.io, prev_nlines, [])
        end
    end
    sticky
end

# Count newlines in a message or sequence of messages
_countlines(msg::String) = sum(c->c=='\n', msg)
_countlines(messages) = length(messages) > 0 ? sum(_countlines, messages) : 0
_countlines(messages::Vector{<:Pair}) = _countlines(m[2] for m in messages)

# Selected TTY cursor and screen control via ANSI codes
# * https://en.wikipedia.org/wiki/ANSI_escape_code#CSI_sequences
# * See man terminfo on linux, eg `tput csr $row1 $row2` and `tput cup $row $col`
# * For windows see https://docs.microsoft.com/en-us/windows/console/console-virtual-terminal-sequences
change_scroll_region!(io, rows::Pair) = write(io, "\e[$(rows[1]);$(rows[2])r")
change_cursor_line!(io, line::Integer) = write(io, "\e[$line;1H")
clear_to_end!(io) = write(io, "\e[J")

function showsticky(io, prev_nlines, messages)
    height,_ = displaysize(io)
    iob = IOBuffer()
    if prev_nlines > 0
        change_cursor_line!(iob, height + 1 - prev_nlines)
        clear_to_end!(iob)
    end
    # Set scroll region to the first N lines.
    #
    # Terminal scrollback buffers seem to be populated with a heuristic which
    # relies on the scrollable region starting at the first row, so to have
    # normal scrollback work we have to position sticky messages at the bottom
    # of the screen.
    linesrequired = _countlines(messages)
    if prev_nlines < linesrequired
        # Scroll screen up to preserve the lines which we will overwrite
        change_cursor_line!(iob, height - prev_nlines)
        write(iob, "\n"^(linesrequired-prev_nlines))
    end
    if prev_nlines != linesrequired
        change_scroll_region!(iob, 1=>height-linesrequired)
    end
    # Write messages. Avoid writing \n of last message to kill extra scrolling
    if !isempty(messages)
        change_cursor_line!(iob, height + 1 - linesrequired)
        for i = 1:length(messages)-1
            write(iob, messages[i][2])
        end
        write(iob, chop(messages[end][2]))
    end
    # TODO: Ideally we'd query the terminal for the line it was on before doing
    # all this and restore it if it's not in the new non-scrollable region.
    change_cursor_line!(iob, height - max(prev_nlines, linesrequired))
    # Write in one block to make the whole operation as atomic as possible.
    write(io, take!(iob))
    nothing
end

function Base.push!(sticky::StickyMessages, message::Pair)
    if !sticky.ansi_codes
        println(sticky.io, rstrip(message[2]))
        return
    end
    label,text = message
    endswith(text, '\n') || (text *= '\n';)
    prev_nlines = _countlines(sticky.messages)
    idx = findfirst(m->m[1] == label, sticky.messages)
    if idx === nothing
        push!(sticky.messages, label=>text)
    else
        sticky.messages[idx] = label=>text
    end
    showsticky(sticky.io, prev_nlines, sticky.messages)
end

function Base.pop!(sticky::StickyMessages, label)
    sticky.ansi_codes || return
    idx = findfirst(m->m[1] == label, sticky.messages)
    if idx !== nothing
        prev_nlines = _countlines(sticky.messages)
        deleteat!(sticky.messages, idx)
        showsticky(sticky.io, prev_nlines, sticky.messages)
    end
    nothing
end

function Base.empty!(sticky::StickyMessages)
    sticky.ansi_codes || return
    prev_nlines = _countlines(sticky.messages)
    empty!(sticky.messages)
    showsticky(sticky.io, prev_nlines, sticky.messages) # Resets scroll region
    nothing
end

using TerminalLoggers: StickyMessages

@testset "Sticky messages without ANSI codes" begin
    buf = IOBuffer()
    # Without TTY, messages are just piped through
    stickies = StickyMessages(buf, ansi_codes=false)
    push!(stickies, :a=>"Msg\n")
    @test String(take!(buf)) == "Msg\n"
    push!(stickies, :a=>"Msg\n")
    @test String(take!(buf)) == "Msg\n"
    pop!(stickies, :a)
    @test String(take!(buf)) == ""
end

@testset "Sticky messages with ANSI codes" begin
    buf = IOBuffer()
    dsize = (20, 80) # Intentionally different from default of 25 rows
    # In TTY mode, we generate various escape codes.
    stickies = StickyMessages(IOContext(buf, :displaysize=>dsize), ansi_codes=true)
    push!(stickies, :a=>"Msg\n")
    @test String(take!(buf)) ==  #scroll    #csr    #pos   #msg #pos
                                "\e[20;1H\n\e[1;19r\e[20;1HMsg\e[19;1H"
    push!(stickies, :a=>"MsgMsg\n")
    @test String(take!(buf)) == #clear      #msgpos #msg #repos
                               "\e[20;1H\e[J\e[20;1HMsgMsg\e[19;1H"
    push!(stickies, :b=>"BBB\n")
    @test String(take!(buf)) ==
        #clear       #scroll   #csr    #pos    #msgs      #pos
        "\e[20;1H\e[J\e[19;1H\n\e[1;18r\e[19;1HMsgMsg\nBBB\e[18;1H"
    pop!(stickies, :a)
    @test String(take!(buf)) == #clear       #csr    #pos   #msg #pos
                                "\e[19;1H\e[J\e[1;19r\e[20;1HBBB\e[18;1H"
    pop!(stickies, :b)
    @test String(take!(buf)) == #clear       #csr    #pos
                                "\e[20;1H\e[J\e[1;20r\e[19;1H"
    pop!(stickies, :b)
    @test String(take!(buf)) == ""

    push!(stickies, :a=>"αβγ\n")
    @test String(take!(buf)) ==  #scroll    #csr    #pos   #msg #pos
                                "\e[20;1H\n\e[1;19r\e[20;1Hαβγ\e[19;1H"

    push!(stickies, :b=>"msg\n")
    take!(buf)

    # Remove all two messages
    empty!(stickies)
    @test String(take!(buf)) == #clear       #csr    #pos
                                "\e[19;1H\e[J\e[1;20r\e[18;1H"
end

@testset "Sticky messages with ANSI codes" begin
    buf = IOBuffer()
    dsize = (20, 80) # Intentionally different from default of 25 rows
    stickies = StickyMessages(IOContext(buf, :displaysize=>dsize), ansi_codes=true)
    push!(stickies, :a=>"a-msg\n")
    push!(stickies, :b=>"b-msg\n")
    take!(buf)
    finalize(stickies)
    # Hack to allow StickyMessages async cleanup to run
    for i=1:1000
        yield()
    end
    @test String(take!(buf)) == #clear       #csr    #pos
                                "\e[19;1H\e[J\e[1;20r\e[18;1H"
end

using Documenter, TerminalLoggers

makedocs(;
    modules=[TerminalLoggers],
    format=Documenter.HTML(),
    pages=[
        "Home" => "index.md",
    ],
    repo="https://github.com/c42f/TerminalLoggers.jl/blob/{commit}{path}#L{line}",
    sitename="TerminalLoggers.jl",
    authors="Chris Foster <chris42f@gmail.com>"
)

deploydocs(;
    repo="github.com/c42f/TerminalLoggers.jl",
    push_preview=true
)

using Markdown

"""
    TerminalLogger(stream=stderr, min_level=$ProgressLevel; meta_formatter=default_metafmt,
                   show_limited=true, right_justify=0)

Logger with formatting optimized for interactive readability in a text console
(for example, the Julia REPL). This is an enhanced version of the terminal
logger `Logging.ConsoleLogger` which comes installed with Julia by default.

Log levels less than `min_level` are filtered out.

Message formatting can be controlled by setting keyword arguments:

* `meta_formatter` is a function which takes the log event metadata
  `(level, _module, group, id, file, line)` and returns a color (as would be
  passed to printstyled), prefix and suffix for the log message.  The
  default is to prefix with the log level and a suffix containing the module,
  file and line location.
* `show_limited` limits the printing of large data structures to something
  which can fit on the screen by setting the `:limit` `IOContext` key during
  formatting.
* `right_justify` is the integer column which log metadata is right justified
  at. The default is zero (metadata goes on its own line).
"""
struct TerminalLogger <: AbstractLogger
    stream::IO
    min_level::LogLevel
    meta_formatter
    show_limited::Bool
    right_justify::Int
    always_flush::Bool
    margin::Int
    message_limits::Dict{Any,Int}
    sticky_messages::StickyMessages
    bartrees::Vector{Node{ProgressBar}}
    lock::ReentrantLock
end
function TerminalLogger(stream::IO=stderr, min_level=ProgressLevel;
                        meta_formatter=default_metafmt, show_limited=true,
                        right_justify=0, always_flush=false, margin=0)
    TerminalLogger(
        stream,
        min_level,
        meta_formatter,
        show_limited,
        right_justify,
        always_flush,
        margin,
        Dict{Any,Int}(),
        StickyMessages(stream),
        Union{}[],
        ReentrantLock()
    )
end

function shouldlog(logger::TerminalLogger, level, _module, group, id)
    lock(logger.lock) do
        get(logger.message_limits, id, 1) > 0
    end
end

min_enabled_level(logger::TerminalLogger) = logger.min_level

function default_logcolor(level)
    level < Info  ? :blue :
    level < Warn  ? Base.info_color()  :
    level < Error ? Base.warn_color()  :
                    Base.error_color()
end

function default_metafmt(level, _module, group, id, file, line)
    color = default_logcolor(level)
    prefix = (level == Warn ? "Warning" : string(level))*':'
    suffix = ""
    Info <= level < Warn && return color, prefix, suffix
    _module !== nothing && (suffix *= "$(_module)")
    if file !== nothing
        _module !== nothing && (suffix *= " ")
        suffix *= string(file)
        if line !== nothing
            suffix *= ":$(isa(line, UnitRange) ? "$(first(line))-$(last(line))" : line)"
        end
    end
    !isempty(suffix) && (suffix = "@ " * suffix)
    return color, prefix, suffix
end

# Length of a string as it will appear in the terminal (after ANSI color codes
# are removed)
function termlength(str)
    N = 0
    in_esc = false
    for c in str
        if in_esc
            if c == 'm'
                in_esc = false
            end
        else
            if c == '\e'
                in_esc = true
            else
                N += 1
            end
        end
    end
    return N
end

function format_message(message, prefix_width, io_context)
    formatted = sprint(show, MIME"text/plain"(), message, context=io_context)
    msglines = split(chomp(formatted), '\n')
    if length(msglines) > 1
        # For multi-line messages it's possible that the message was carefully
        # formatted with vertical alignemnt. Therefore we play it safe by
        # prepending a blank line.
        pushfirst!(msglines, SubString(""))
    end
    msglines
end

function format_message(message::AbstractString, prefix_width, io_context)
    # For strings, use Markdown to do the formatting. The markdown renderer
    # isn't very composable with other text formatting so this is quite hacky.
    message = Markdown.parse(message)
    prepend_prefix = !isempty(message.content) &&
                     message.content[1] isa Markdown.Paragraph
    if prepend_prefix
        # Hack: We prepend the prefix here to allow the markdown renderer to be
        # aware of the indenting which will result from prepending the prefix.
        # Without this we will get many issues of broken vertical alignment.
        # Avoid collisions: using placeholder from unicode private use area
        placeholder = '\uF8FF'^prefix_width
        pushfirst!(message.content[1].content, placeholder)
    end
    formatted = sprint(show, MIME"text/plain"(), message, context=io_context)
    msglines = split(chomp(formatted), '\n')
    # Hack': strip left margin which can't be configured in Markdown
    # terminal rendering.
    msglines = [startswith(s, "  ") ? s[3:end] : s for s in msglines]
    if prepend_prefix
        # Hack'': Now remove the prefix from the rendered markdown.
        msglines[1] = replace(msglines[1], placeholder=>""; count=1)
    elseif !isempty(msglines[1])
        pushfirst!(msglines, SubString(""))
    end
    msglines
end

# Formatting of values in key value pairs
function showvalue(io, key, msg)
    if key === :exception && msg isa Vector && length(msg) > 1 && msg[1] isa Tuple{Exception,Any}
        if VERSION >= v"1.2"
            # Ugly code path to support passing exception=Base.catch_stack()
            # `Base.ExceptionStack` was only introduced in Julia 1.7.0-DEV.1106
            # https://github.com/JuliaLang/julia/pull/29901 (dispatched on below).
            Base.show_exception_stack(io, msg)
        else
            # v1.0 and 1.1 don't have Base.show_exception_stack
            show(io, MIME"text/plain"(), msg)
        end
    else
        show(io, MIME"text/plain"(), msg)
    end
end
function showvalue(io, key, e::Tuple{Exception,Any})
    ex,bt = e
    showerror(io, ex, bt; backtrace = bt!==nothing)
end
showvalue(io, key, ex::Exception) = showerror(io, ex)

# Generate a text representation of all key value pairs, split into lines with
# per-line indentation as an integer.
function format_key_value_pairs(kwargs, io_context)
    msglines = Tuple{Int,String}[]
    valbuf = IOBuffer()
    dsize = displaysize(io_context)
    rows_per_value = max(1, dsize[1]÷(length(kwargs)+1))
    valio = IOContext(valbuf, IOContext(io_context, :displaysize=>(rows_per_value,dsize[2]-3)))
    for (key,val) in kwargs
        showvalue(valio, key, val)
        vallines = split(String(take!(valbuf)), '\n')
        if length(vallines) == 1
            push!(msglines, (2,SubString("$key = $(vallines[1])")))
        else
            push!(msglines, (2,SubString("$key =")))
            append!(msglines, ((3,line) for line in vallines))
        end
    end
    msglines
end

function findbar(bartree, id)
    if !(bartree isa AbstractArray)
        bartree.data.id === id && return bartree
    end
    for node in bartree
        found = findbar(node, id)
        found === nothing || return found
    end
    return nothing
end

function foldtree(op, acc, tree)
    for node in tree
        acc = foldtree(op, acc, node)
    end
    if !(tree isa AbstractArray)
        acc = op(acc, tree)
    end
    return acc
end

const BAR_MESSAGE_ID = gensym(:BAR_MESSAGE_ID)

function handle_progress(logger, progress, kwargs)
    node = findbar(logger.bartrees, progress.id)
    if node === nothing
        # Don't do anything when it's already done:
        (progress.done || something(progress.fraction, 0.0) >= 1) && return

        parentnode = findbar(logger.bartrees, progress.parentid)
        bar = ProgressBar(
            fraction = progress.fraction,
            name = progress.name,
            id = progress.id,
            parentid = progress.parentid,
        )
        if parentnode === nothing
            node = Node(bar)
            pushfirst!(logger.bartrees, node)
        else
            bar.level = parentnode.data.level + 1
            node = addchild(parentnode, bar)
        end
    else
        bar = node.data
        set_fraction!(bar, progress.fraction)
        if progress.name != ""
            bar.name = progress.name
        end
        node.data = bar
    end
    if progress.done
        if isroot(node)
            deleteat!(logger.bartrees, findfirst(x -> x === node, logger.bartrees))
        else
            prunebranch!(node)
        end
    end

    bartxt = sprint(context = :displaysize => displaysize(logger.stream)) do io
        foldtree(true, logger.bartrees) do isfirst, node
            isfirst || println(io)
            printprogress(io, node.data)
            false  # next `isfirst`
        end
    end
    if isempty(bartxt)
        pop!(logger.sticky_messages, BAR_MESSAGE_ID)
    else
        bartxt = sprint(context = logger.stream) do io
            printstyled(io, bartxt; color=:green)
        end
        push!(logger.sticky_messages, BAR_MESSAGE_ID => bartxt)
    end

    # "Flushing" non-sticky message should be done after the sticky
    # message is re-drawn:
    if progress.done
        ensure_done!(bar)
        donetxt = sprint(context = :displaysize => displaysize(logger.stream)) do io
            printprogress(io, bar)
        end
        printstyled(logger.stream, donetxt; color=:light_black)
        println(logger.stream)
    end

    if logger.always_flush
        flush(logger.stream)
    end
end

function handle_message(logger::TerminalLogger, level, message, _module, group, id,
                        filepath, line; maxlog=nothing,
                        sticky=nothing, kwargs...)
    if maxlog !== nothing && maxlog isa Integer
        remaining = 0
        lock(logger.lock) do
            remaining = get!(logger.message_limits, id, maxlog)
            logger.message_limits[id] = remaining - 1
        end
        remaining > 0 || return
    end

    progress = asprogress(level, message, _module, group, id, filepath, line; kwargs...)
    if progress !== nothing
        lock(logger.lock) do
            handle_progress(logger, progress, kwargs)
        end
        return
    end

    color,prefix,suffix = logger.meta_formatter(level, _module, group, id, filepath, line)

    # Generate a text representation of the message
    dsize = displaysize(logger.stream)
    context = IOContext(logger.stream, :displaysize=>(dsize[1],dsize[2]-2))
    msglines = format_message(message, textwidth(prefix), context)
    # Add indentation level
    msglines = [(0,l) for l in msglines]
    if !isempty(kwargs)
        ctx = logger.show_limited ? IOContext(context, :limit=>true) : context
        append!(msglines, format_key_value_pairs(kwargs, ctx))
    end

    # Format lines as text with appropriate indentation and with a box
    # decoration on the left.
    minsuffixpad = 2
    buf = IOBuffer()
    iob = IOContext(buf, logger.stream)
    nonpadwidth = 2 + (isempty(prefix) || length(msglines) > 1 ? 0 : length(prefix)+1) +
                  msglines[end][1] + termlength(msglines[end][2]) +
                  (isempty(suffix) ? 0 : length(suffix)+minsuffixpad)
    justify_width = min(logger.right_justify, dsize[2])
    if nonpadwidth > justify_width && !isempty(suffix)
        push!(msglines, (0,SubString("")))
        minsuffixpad = 0
        nonpadwidth = 2 + length(suffix)
    end
    for (i,(indent,msg)) in enumerate(msglines)
        boxstr = length(msglines) == 1 ? "[ " :
                 i == 1                ? "┌ " :
                 i < length(msglines)  ? "│ " :
                                         "└ "
        printstyled(iob, boxstr, bold=true, color=color)
        if i == 1 && !isempty(prefix)
            printstyled(iob, prefix, " ", bold=true, color=color)
        end
        print(iob, " "^indent, msg)
        if i == length(msglines) && !isempty(suffix)
            npad = max(0, justify_width - nonpadwidth) + minsuffixpad
            print(iob, " "^npad)
            printstyled(iob, suffix, color=:light_black)
        end
        println(iob)
    end
    
    if sticky === nothing
        for _ in 1:logger.margin
            println(iob)
        end
    end

    msg = take!(buf)

    lock(logger.lock) do
        if sticky !== nothing
            # Ensure we see the last message, even if it's :done
            push!(logger.sticky_messages, id=>String(msg))
            if sticky == :done
                pop!(logger.sticky_messages, id)
            end
        else
            write(logger.stream, msg)
        end
        
        if logger.always_flush
            flush(logger.stream)
        end
    end

    nothing
end

using TerminalLoggers
using Test

using Logging:
    LogLevel, BelowMinLevel, Debug, Info, Warn, Error, AboveMaxLevel,
    shouldlog, handle_message, min_enabled_level, catch_exceptions,
    with_logger

using ProgressLogging: Progress
using UUIDs: UUID

include("TerminalLogger.jl")
include("StickyMessages.jl")

using TerminalLoggers: default_metafmt, format_message

using ProgressLogging

@noinline func1() = backtrace()

function dummy_metafmt(level, _module, group, id, file, line)
    :cyan,"PREFIX","SUFFIX"
end

# Log formatting
function genmsgs(events; level=Info, _module=Main,
                 file="some/path.jl", line=101, color=false, width=75,
                 meta_formatter=dummy_metafmt, show_limited=true,
                 right_justify=0)
    buf = IOBuffer()
    io = IOContext(buf, :displaysize=>(30,width), :color=>color)
    logger = TerminalLogger(io, Debug,
                            meta_formatter=meta_formatter,
                            show_limited=show_limited,
                            right_justify=right_justify)
    prev_have_color = Base.have_color
    return map(events) do (message, kws)
        kws = Dict(pairs(kws))
        id = pop!(kws, :_id, :an_id)
        # Avoid markdown formatting while testing layouting. Don't wrap
        # progress messages though; ProgressLogging.asprogress() doesn't
        # like that.
        is_progress = message isa Progress || haskey(kws, :progress)
        handle_message(logger, level, message, _module, :a_group, id,
                       file, line; kws...)
        String(take!(buf))
    end
end

function genmsg(message; kwargs...)
    kws = Dict(kwargs)
    logconfig = Dict(
        k => pop!(kws, k)
        for k in [
            :level,
            :_module,
            :file,
            :line,
            :color,
            :width,
            :meta_formatter,
            :show_limited,
            :right_justify,
        ] if haskey(kws, k)
    )
    return genmsgs([(message, kws)]; logconfig...)[1]
end

@testset "TerminalLogger" begin
    # First pass log limiting
    @test min_enabled_level(TerminalLogger(devnull, Debug)) == Debug
    @test min_enabled_level(TerminalLogger(devnull, Error)) == Error

    # Second pass log limiting
    logger = TerminalLogger(devnull)
    @test shouldlog(logger, Info, Base, :group, :asdf) === true
    handle_message(logger, Info, "msg", Base, :group, :asdf, "somefile", 1, maxlog=2)
    @test shouldlog(logger, Info, Base, :group, :asdf) === true
    handle_message(logger, Info, "msg", Base, :group, :asdf, "somefile", 1, maxlog=2)
    @test shouldlog(logger, Info, Base, :group, :asdf) === false

    @testset "Default metadata formatting" begin
        @test default_metafmt(Info,  Main, :g, :i, "a.jl", 1) ==
            (:cyan,      "Info:",    "")
        @test default_metafmt(Warn,  Main, :g, :i, "b.jl", 2) ==
            (:yellow,    "Warning:", "@ Main b.jl:2")
        @test default_metafmt(Error, Main, :g, :i, "", 0) ==
            (:light_red, "Error:",   "@ Main :0")
        # formatting of nothing
        @test default_metafmt(Warn,  nothing, :g, :i, "b.jl", 2) ==
            (:yellow,    "Warning:", "@ b.jl:2")
        @test default_metafmt(Warn,  Main, :g, :i, nothing, 2) ==
            (:yellow,    "Warning:", "@ Main")
        @test default_metafmt(Warn,  Main, :g, :i, "b.jl", nothing) ==
            (:yellow,    "Warning:", "@ Main b.jl")
        @test default_metafmt(Warn,  nothing, :g, :i, nothing, 2) ==
            (:yellow,    "Warning:", "")
        @test default_metafmt(Warn,  Main, :g, :i, "b.jl", 2:5) ==
            (:yellow,    "Warning:", "@ Main b.jl:2-5")
    end

    # Basic tests for the default setup
    @test genmsg("msg", level=Info, meta_formatter=default_metafmt) ==
    """
    [ Info: msg
    """
    @test genmsg("msg", level=Warn, _module=Base,
                 file="other.jl", line=42, meta_formatter=default_metafmt) ==
    """
    ┌ Warning: msg
    └ @ Base other.jl:42
    """
    # Full metadata formatting
    @test genmsg("msg", level=Debug,
                 meta_formatter=(level, _module, group, id, file, line)->
                                (:white,"Foo!", "$level $_module $group $id $file $line")) ==
    """
    ┌ Foo! msg
    └ Debug Main a_group an_id some/path.jl 101
    """

    @testset "Prefix and suffix layout" begin
        @test genmsg("") ==
        replace("""
        ┌ PREFIX EOL
        └ SUFFIX
        """, "EOL"=>"")
        @test genmsg("msg") ==
        """
        ┌ PREFIX msg
        └ SUFFIX
        """
        # Behavior with empty prefix / suffix
        @test genmsg("msg", meta_formatter=(args...)->(:white, "PREFIX", "")) ==
        """
        [ PREFIX msg
        """
        @test genmsg("msg", meta_formatter=(args...)->(:white, "", "SUFFIX")) ==
        """
        ┌ msg
        └ SUFFIX
        """
    end

    @testset "Metadata suffix, right justification" begin
        @test genmsg("xxx", width=20, right_justify=200) ==
        """
        [ PREFIX xxx  SUFFIX
        """
        @test genmsg("xxxxxxxx xxxxxxxx", width=20, right_justify=200) ==
        """
        ┌ PREFIX xxxxxxxx
        └ xxxxxxxx    SUFFIX
        """
        # When adding the suffix would overflow the display width, add it on
        # the next line:
        @test genmsg("xxxx", width=20, right_justify=200) ==
        """
        ┌ PREFIX xxxx
        └             SUFFIX
        """
        # Same for multiline messages
        @test genmsg("""xxx
                        xxxxxxxxxx""", width=20, right_justify=200) ==
        """
        ┌ PREFIX xxx
        └ xxxxxxxxxx  SUFFIX
        """
        @test genmsg("""xxx
                        xxxxxxxxxxx""", width=20, right_justify=200) ==
        """
        ┌ PREFIX xxx
        │ xxxxxxxxxxx
        └             SUFFIX
        """
        # min(right_justify,width) is used
        @test genmsg("xxx", width=200, right_justify=20) ==
        """
        [ PREFIX xxx  SUFFIX
        """
        @test genmsg("xxxx", width=200, right_justify=20) ==
        """
        ┌ PREFIX xxxx
        └             SUFFIX
        """
    end

    # Keywords
    @test genmsg("msg", a=1, b="asdf") ==
    """
    ┌ PREFIX msg
    │   a = 1
    │   b = "asdf"
    └ SUFFIX
    """
    # Exceptions shown with showerror
    @test genmsg("msg", exception=DivideError()) ==
    """
    ┌ PREFIX msg
    │   exception = DivideError: integer division error
    └ SUFFIX
    """

    # Attaching backtraces
    bt = func1()
    @test startswith(genmsg("msg", exception=(DivideError(),bt)),
    """
    ┌ PREFIX msg
    │   exception =
    │    DivideError: integer division error
    │    Stacktrace:""")
    @test occursin("[1] func1", genmsg("msg", exception=(DivideError(),bt)))

    # Exception stacks
    if VERSION >= v"1.2"
        excstack = try
            error("Root cause")
        catch
            try
                error("An exception")
            catch
                if VERSION >= v"1.7.0-DEV.1106"
                    current_exceptions()
                else
                    Base.catch_stack()
                end
            end
        end
        @test occursin(r"An exception.*Stacktrace.*caused by.*Root cause.*Stacktrace"s,
                       genmsg("msg", exception=excstack))
    end

    @testset "Limiting large data structures" begin
        a = fill(1.00001, 10,10)
        b = fill(2.00002, 10,10)
        @test genmsg("msg", a=a, b=b) ==
        replace("""
        ┌ PREFIX msg
        │   a =
        │    $(summary(a)):
        │     1.00001  1.00001  1.00001  1.00001  …  1.00001  1.00001  1.00001
        │     1.00001  1.00001  1.00001  1.00001     1.00001  1.00001  1.00001
        │     1.00001  1.00001  1.00001  1.00001     1.00001  1.00001  1.00001
        │     ⋮                                   ⋱                           EOL
        │     1.00001  1.00001  1.00001  1.00001     1.00001  1.00001  1.00001
        │     1.00001  1.00001  1.00001  1.00001     1.00001  1.00001  1.00001
        │   b =
        │    $(summary(b)):
        │     2.00002  2.00002  2.00002  2.00002  …  2.00002  2.00002  2.00002
        │     2.00002  2.00002  2.00002  2.00002     2.00002  2.00002  2.00002
        │     2.00002  2.00002  2.00002  2.00002     2.00002  2.00002  2.00002
        │     ⋮                                   ⋱                           EOL
        │     2.00002  2.00002  2.00002  2.00002     2.00002  2.00002  2.00002
        │     2.00002  2.00002  2.00002  2.00002     2.00002  2.00002  2.00002
        └ SUFFIX
        """,
        # EOL hack to work around git whitespace errors
        # VERSION dependence due to JuliaLang/julia#33339
        (VERSION < v"1.4-" ? "EOL" : "       EOL")=>""
        )
        # Limiting the amount which is printed
        @test genmsg("msg", a=a, show_limited=false) ==
        """
        ┌ PREFIX msg
        │   a =
        │    $(summary(a)):
        │     1.00001  1.00001  1.00001  1.00001  1.00001  1.00001  1.00001  1.00001  1.00001  1.00001
        │     1.00001  1.00001  1.00001  1.00001  1.00001  1.00001  1.00001  1.00001  1.00001  1.00001
        │     1.00001  1.00001  1.00001  1.00001  1.00001  1.00001  1.00001  1.00001  1.00001  1.00001
        │     1.00001  1.00001  1.00001  1.00001  1.00001  1.00001  1.00001  1.00001  1.00001  1.00001
        │     1.00001  1.00001  1.00001  1.00001  1.00001  1.00001  1.00001  1.00001  1.00001  1.00001
        │     1.00001  1.00001  1.00001  1.00001  1.00001  1.00001  1.00001  1.00001  1.00001  1.00001
        │     1.00001  1.00001  1.00001  1.00001  1.00001  1.00001  1.00001  1.00001  1.00001  1.00001
        │     1.00001  1.00001  1.00001  1.00001  1.00001  1.00001  1.00001  1.00001  1.00001  1.00001
        │     1.00001  1.00001  1.00001  1.00001  1.00001  1.00001  1.00001  1.00001  1.00001  1.00001
        │     1.00001  1.00001  1.00001  1.00001  1.00001  1.00001  1.00001  1.00001  1.00001  1.00001
        └ SUFFIX
        """
    end

    # Basic colorization test.
    @test genmsg("line1\n\nline2", color=true) ==
    """
    \e[36m\e[1m┌ \e[22m\e[39m\e[36m\e[1mPREFIX \e[22m\e[39mline1
    \e[36m\e[1m│ \e[22m\e[39m
    \e[36m\e[1m│ \e[22m\e[39mline2
    \e[36m\e[1m└ \e[22m\e[39m\e[90mSUFFIX\e[39m
    """

    # Using infix operator so that `@test` prints lhs and rhs when failed:
    ⊏(s, re) = match(re, s) !== nothing

    @test genmsg("", progress=0.1, width=60) ⊏
    r"Progress:  10%\|█+.* +\|  ETA: .*"
    @test genmsg("", progress=NaN, width=60) ⊏
    r"Progress:   0%\|. +\|  ETA: .*"
    @test genmsg("", progress=1.0, width=60) == ""
    @test genmsg("", progress="done", width=60) == ""
    @test genmsgs([("", (progress = 0.1,)), ("", (progress = 1.0,))], width = 60)[end] ⊏
    r"Progress: 100%\|█+\| Time: .*"
    @test genmsgs([("", (progress = 0.1,)), ("", (progress = "done",))], width = 60)[end] ⊏
    r"Progress: 100%\|█+\| Time: .*"

    @testset "Message formatting" begin
        io_ctx = IOContext(IOBuffer(), :displaysize=>(20,20))

        # Short paragraph on a single line
        @test format_message("Hi `code`", 6, io_ctx) ==
            ["Hi code"]

        # Longer paragraphs wrap around the prefix
        @test format_message("x x x x x x x x x x x x x x x x x x x x x", 6, io_ctx) ==
             ["x x x x x"
              "x x x x x x x x"
              "x x x x x x x x"]

        # Markdown block elements get their own lines
        @test format_message("# Hi", 6, io_ctx) ==
            ["",
             "Hi",
             VERSION < v"1.10-DEV" ? "≡≡≡≡" : "≡≡"]

        # For non-strings a blank line is added so that any formatting for
        # vertical alignment isn't broken
        @test format_message(Text(" 1  2\n 3  4"), 6, io_ctx) ==
            ["",
             " 1  2",
             " 3  4"]
    end

    @testset "Independent progress bars" begin
        msgs = genmsgs([
            ("Bar1", (progress = 0.0, _id = 1111)), # 1
            ("Bar2", (progress = 0.5, _id = 2222)),
            ("Bar2", (progress = 1.0, _id = 2222)), # 3
            ("", (progress = "done", _id = 2222)),  # 4
            ("Bar1", (progress = 0.2, _id = 1111)), # 5
            ("Bar2", (progress = 0.5, _id = 2222)),
            ("Bar2", (progress = 1.0, _id = 2222)), # 7
            ("", (progress = "done", _id = 2222)),  # 8
            ("Bar1", (progress = 0.4, _id = 1111)),
            ("", (progress = "done", _id = 1111)),
        ]; width=60)
        @test msgs[1] ⊏ r"""
        Bar1   0%\|. +\|  ETA: N/A
        """
        @test msgs[3] ⊏ r"""
        Bar2 100%\|█+\| Time: .*
        Bar1   0%\|. +\|  ETA: .*
        """
        @test msgs[4] ⊏ r"""
        Bar1   0%\|. +\|  ETA: .*
        Bar2 100%\|█+\| Time: .*
        """
        @test msgs[5] ⊏ r"""
        Bar1  20%\|█+.* +\|  ETA: .*
        """
        @test msgs[7] ⊏ r"""
        Bar2 100%\|█+\| Time: .*
        Bar1  20%\|█+.* +\|  ETA: .*
        """
        @test msgs[8] ⊏ r"""
        Bar1  20%\|█+.* +\|  ETA: .*
        Bar2 100%\|█+\| Time: .*
        """
        @test msgs[end] ⊏ r"""
        Bar1 100%\|█+\| Time: .*
        """
    end

    @testset "Nested progress bars" begin
        id_outer = UUID(100)
        id_inner_1 = UUID(201)
        id_inner_2 = UUID(202)
        outermsg(fraction; kw...) =
            (Progress(id_outer, fraction; name = "Outer", kw...), Dict())
        innermsg(id, fraction; kw...) =
            (Progress(id, fraction; name = "Inner", parentid = id_outer, kw...), Dict())
        msgs = genmsgs([
            outermsg(0.0),                              # 1
            innermsg(id_inner_1, 0.5),
            innermsg(id_inner_1, 1.0),                  # 3
            innermsg(id_inner_1, nothing; done = true), # 4
            outermsg(0.2),                              # 5
            innermsg(id_inner_2, 0.5),
            innermsg(id_inner_2, 1.0),                  # 7
            innermsg(id_inner_2, nothing; done = true), # 8
            outermsg(0.4),
            outermsg(nothing; done = true),
        ]; width=60)
        @test msgs[1] ⊏ r"""
        Outer   0%\|. +\|  ETA: N/A
        """
        @test msgs[3] ⊏ r"""
          Inner 100%\|█+\| Time: .*
        Outer   0%\|. +\|  ETA: .*
        """
        @test msgs[4] ⊏ r"""
        Outer   0%\|. +\|  ETA: .*
          Inner 100%\|█+\| Time: .*
        """
        @test msgs[5] ⊏ r"""
        Outer  20%\|█+.* +\|  ETA: .*
        """
        @test msgs[7] ⊏ r"""
          Inner 100%\|█+\| Time: .*
        Outer  20%\|█+.* +\|  ETA: .*
        """
        @test msgs[8] ⊏ r"""
        Outer  20%\|█+.* +\|  ETA: .*
          Inner 100%\|█+\| Time: .*
        """
        @test msgs[end] ⊏ r"""
        Outer 100%\|█+\| Time: .*
        """
    end

    @static if VERSION >= v"1.3.0"
        @testset "Parallel progress" begin
            buf = IOBuffer()
            io = IOContext(buf, :displaysize=>(30,75), :color=>false)
            logger = TerminalLogger(io, Debug)
            # Crude multithreading test: generate some contention.
            #
            # Generate some contention in multi-threaded cases
            ntasks = 8
            @sync begin
                with_logger(logger) do
                    for i=1:ntasks
                        Threads.@spawn for j=1:100
                            @info "XXXX <$i,$j>" maxlog=100
                            #sleep(0.001)
                        end
                    end
                end
            end
            log_str = String(take!(buf))
            @test length(findall("XXXX", log_str)) == 100

            # Fun test of parallel progress logging to watch interactively:
            #=
            using ProgressLogging
            @sync begin
                for i=1:8
                    Threads.@spawn @progress name="task $i" threshold=0.00005 for j=1:10000
                        #sleep(0.001)
                    end
                end
            end
            =#
        end
    end
end

# TerminalLoggers.jl

TerminalLoggers provides a logger type [`TerminalLogger`](@ref) which can
format your log messages in a richer way than the default `ConsoleLogger` which
comes with the julia standard `Logging` library.


## Installation and setup

```julia-repl
pkg> add TerminalLoggers
```

To use `TerminalLogger` in all your REPL sessions by default, you may add a
snippet such as the following to your startup file (in `.julia/config/startup.jl`)

```julia
atreplinit() do repl
    try
        @eval begin
            using Logging: global_logger
            using TerminalLoggers: TerminalLogger
            global_logger(TerminalLogger())
        end
    catch
    end
end
```

## Markdown

`TerminalLogger` interprets all `AbstractString` log messages as markdown so
you can use markdown formatting to display readable formatted messages. For
example,

```
@info """
    # A heading

    About to do the following

    * A list
    * Of actions
    * To take
    """
```

## Progress bars

`TerminalLogger` displays progress logging as a set of progress bars which are
cleanly separated from the rest of the program output at the bottom of the
terminal.

For robust progress logging, `TerminalLoggers` recognizes the `Progress` type
from the [`ProgressLogging` package](https://github.com/JuliaLogging/ProgressLogging.jl).
For easy to use progress reporting you can therefore use the `@progress` macro:

```julia
using Logging: global_logger
global_logger(TerminalLogger(right_justify=120))
using ProgressLogging

@progress for i=1:100
    if i == 50
        @info "Middle of computation" i
    elseif i == 70
        println("Normal output does not interfere with progress bars")
    end
    sleep(0.01)
end
@info "Done"
```

!!! note
    On Windows, rendering progress bars requires julia 1.5.3 or later,
    and scrolling works best on a modern terminal like Windows Terminal.

You can also use the older progress logging API with the `progress=fraction`
key value pair. This is simpler but has some downsides such as not interacting
correctly with exceptions.

## API Reference

```@docs
TerminalLogger
```
